package com.xhkjedu.smarking.service.scan;

import com.xhkjedu.smarking.mapper.scan.MsScanbatchPaperBlockMapper;
import com.xhkjedu.smarking.mapper.scan.MsScanbatchPaperBlockQuestionMapper;
import com.xhkjedu.smarking.mapper.scan.MsScanbatchPaperMapper;
import com.xhkjedu.smarking.model.scan.MsScanbatchPaper;
import com.xhkjedu.smarking.model.scan.MsScanbatchPaperBlock;
import com.xhkjedu.smarking.model.scan.MsScanbatchPaperBlockQuestion;
import com.xhkjedu.utils.N_Utils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * @Description 批阅扫描试卷表 服务实现类
 * @Author auto
 * @Date 2024-10-15
 */
@Service
public class MsScanbatchPaperService {
    @Resource
    private MsScanbatchPaperMapper msScanbatchPaperMapper;
    @Resource
    private MsScanbatchPaperBlockMapper msScanbatchPaperBlockMapper;
    @Resource
    private MsScanbatchPaperBlockQuestionMapper msScanbatchPaperBlockQuestionMapper;

    /**
     * @Description 新增
     * @Param [msScanbatchPaper]
     * @Author auto
     * @Date 2024-10-15
     * @return void
     **/
    @Transactional(rollbackFor = Exception.class)
    public void add(MsScanbatchPaper msScanbatchPaper){

        msScanbatchPaper.setCreatetime(N_Utils.getSecondTimestamp());
        msScanbatchPaperMapper.insertUseGeneratedKeys(msScanbatchPaper);
        Integer mspid = msScanbatchPaper.getId();

        //保存试题
        List<MsScanbatchPaperBlock> spblocks = msScanbatchPaper.getSpblocks();
        for (MsScanbatchPaperBlock spblock : spblocks) {
            spblock.setMspid(mspid);
            spblock.setBatchid(msScanbatchPaper.getBatchid());
        }

        msScanbatchPaperBlockMapper.insertList(spblocks);
        List<MsScanbatchPaperBlockQuestion> saveQuestions = new ArrayList<>();
        for (MsScanbatchPaperBlock spblock : spblocks) {
            Integer spbid = spblock.getId();
            List<MsScanbatchPaperBlockQuestion> spbquestions = spblock.getSpbquestions();
            for (MsScanbatchPaperBlockQuestion spbquestion : spbquestions) {
                spbquestion.setMspbid(spbid);
                saveQuestions.add(spbquestion);
            }
        }
        msScanbatchPaperBlockQuestionMapper.insertList(saveQuestions);
    }


    /*
     * @Description 扫描记录-查看原卷
     * @Date 2024/10/25 17:22:45
     * @Author WN
     * @Param [mspid]
     * @Return java.util.Map<java.lang.String,java.lang.Object>
     **/
    public Map<String,Object> getScanPaperQuestion(Integer mspid){
        Map<String,Object> map = msScanbatchPaperMapper.getScanPaperByMspid(mspid);
        //获取试卷中客观题
        List<Map<String,Object>> objectives = msScanbatchPaperBlockMapper.listObjectiveQuestions(mspid);
        map.put("objectives",objectives);
        //获取试卷中主观题
        List<Map<String,Object>> subjectives = msScanbatchPaperBlockMapper.listSubjectiveQuestions(mspid);
        map.put("subjectives",subjectives);

        return map;
    }
}
